//
//  iSVG3x.m
//  iSVG3x
//
//  Created by b4j on 26/11/2015.
//  Copyright © 2015 Anywhere Software. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <SVGKit/SVGKit.h>
#import "iSVG3x.h"

@implementation iSVG3x

#define OBJECT ((SVGKImage *) self.object)

+(Class) getClass { return [SVGKImage class]; }

@synthesize Width           = _width;
@synthesize Height          = _height;
@synthesize KeepAspectRatio = _keepAspectRatio;
@synthesize Tag             = _tag;

/**
 * Initializes the SVG object and loads the file.
 */
- (void) Initialize: (NSString *) Directory : (NSString *) FileName {
    NSString * path = [[[B4ICommon shared] File] checkAssets: Directory : FileName : false];
    SVGKImage* image = [SVGKImage imageWithContentsOfFile: [[[B4ICommon shared] File] Combine: Directory : path]];
    if (image == nil)
       {
       [NSException raise: @"" format: @"Error loading SVG file."];
       }
       else
       {
       if (image.hasSize) { _width = image.size.width; _height = image.size.height; }
       else { _width = -1; _height = -1; }
       }
       _keepAspectRatio = false;
       self.object = image;
}

/**
 * Exports the loaded SVG to a Bitmap.
 */
- (B4IBitmap *) Export: (float) desiredWidth : (float) desiredHeight {
    if (OBJECT == nil) { return nil; }
    float imageWidth = desiredWidth;
    float imageHeight = desiredHeight;
    if (_keepAspectRatio && (_width > 0) && (_height > 0))
       {
       imageHeight = desiredWidth * (_height / _width);
       if (imageHeight > desiredHeight) { imageHeight = desiredHeight; }
       imageWidth = imageHeight / (_height / _width);
       }
    OBJECT.size = CGSizeMake (imageWidth, imageHeight);
    return (B4IBitmap *) [B4IObjectWrapper createWrapper: [B4IBitmap new] object: OBJECT.UIImage];    
}

- (void) setWidth: (float) value { _width = value; }
- (float) Width { return _width; }

- (void) setHeight: (float) value { _height = value; }
- (float) Height { return _height; }

- (void) setKeepAspectRatio: (bool) value { _keepAspectRatio = value; }
- (bool) KeepAspectRatio { return _keepAspectRatio; }

- (void) setTag: (NSObject *) value { _tag = value; }
- (NSObject *) Tag { return _tag; }

@end
